// Interfacce multiple, con confronto come metodo

interface Figure {

    /* gli oggetti delle classi che realizzano questa interfaccia sono 
       caratterizzati da
         un tipo 
	 un area
    */
    
    double area();

    String tipo();

}

abstract class FigureComparabili implements Figure, Comparable {

    protected double dim1;
    protected double dim2;

    FigureComparabili(double a, double b) {
	dim1 = a;
	dim2 = b;
    }

    // lascia astratti i metodi di Figure
    abstract public double area();
    abstract public String tipo();

    // definisce compare() di Comparable (uguale per tutte le figure)
    public int compareTo(Object o) {
	double a1 = this.area();
	double a2 = ((FigureComparabili)o).area(); // il cast serve
	return (int)(a1-a2) ;
    }

}

class Rectangle extends FigureComparabili {

    Rectangle(double a, double b) {
	super(a, b);
    }

    // definisce area() di Figure
    public double area() {
	return dim1 * dim2;
    }

    // definisce tipo() di Figure
    public String tipo() {
	return "Rectangle ";
    }

}

class Triangle extends FigureComparabili {
        Triangle(double a, double b) {
                super(a, b);
        }
    // definisce area() di Figure
    public double area() {
	return dim1 * dim2 / 2;
    }

    // definisce tipo() di Figure
    public String tipo() {
	return "Triangle ";
    } 
}

class Interfacce2 {

    public static void main(String args[]) {
	
	FigureComparabili f1,f2; 

	f1 = new Rectangle(9, 5);
	System.out.println(f1.tipo() + f1.area());
	f2= new Triangle(10, 8);
	System.out.println(f2.tipo() + f2.area());
	System.out.println("Confronto: " + f1.compareTo(f2));

    }
}

